Attribute VB_Name = "Module1"
Public tw As Integer
Public th As Integer

Public bmfh As bmfileheader
Public bmh As Bmheader
Public BMPBuffer() As Byte

Public Colormap() As Long


Type bmfileheader
bfType1 As Byte
bftype2 As Byte
bfSize As Long
bfReserved1 As Integer
bfReserved2 As Integer
bfOffBits As Long
End Type

Type Bmheader
biSize As Long
biWidth As Long
biHeight As Long
biPlanes As Integer
biBitcount As Integer
biCompression As Long
biSizeImage As Long
biXpelsPerMeter As Long
biYPelsPerMeter As Long
biClrUsed As Long
biClrImportant As Long
'not sure if there should be a bmiColors entry since there's no color map?
End Type




Sub Main()
'*** GENERIC BMP EXAMPLE ***
'Allmost identical to the bmp import filter plugin.
'it currently loads 24 and 8 bit bmps

Dim x As Integer, y As Integer
Dim r As Long, g As Long, b As Long, c As Long


'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")



'dim the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
'with brushes, we have to set the a buffer if only to all &HFF
Dim MainABuffer() As Byte

'warn the user, 'this is only a stupid example'
'Dogwaffle.Dog_MessageBox ("This is an example of an import filter.  It currently loads 8 and 24 bit bmps.  Your current buffer will be overwritten.")




MyFilename = Dogwaffle.Dog_RequestFile_Open("Select a bmp", "", "bmp(*.bmp)|*.bmp")
If MyFilename = "" Then GoTo SkipAll

'read the bmp into the input buffer

result = ReadBMP(MyFilename)

If result = -1 Then
 Dogwaffle.Dog_MessageBox ("Not a BMP")
 GoTo SkipAll
End If

If result = -2 Then
 Dogwaffle.Dog_MessageBox ("Currently loads only 8 and 24 bit files")
 GoTo SkipAll
End If

If result = -3 Then
 Dogwaffle.Dog_MessageBox ("Compression not currently supported.")
 GoTo SkipAll
End If

If result > 0 Then GoTo SkipAll



'create a new brush in dogwaffle with the size of the bmp

tw = bmh.biWidth
th = bmh.biHeight

Dogwaffle.Dog_CreateEmptyBrush tw, th

'dim the buffers
ReDim MainRBuffer(tw, th)
ReDim MainGBuffer(tw, th)
ReDim MainBBuffer(tw, th)
'for brushes, we must use the a buffer
ReDim MainABuffer(tw, th)

'read image from the rgb buffer into the sepperate r,g,b buffers.
Dim x2 As Integer
Dim y2 As Integer
'is it a 24 bit image?
If bmh.biBitcount = 24 Then
For y = 0 To th - 1
x2 = 0
y2 = ((th - 1) - y)
    For x = 0 To tw - 1
        b = BMPBuffer((x * 3), y)
        g = BMPBuffer((x * 3) + 1, y)
        r = BMPBuffer((x * 3) + 2, y)

        MainRBuffer(x, y2) = r
        MainGBuffer(x, y2) = g
        MainBBuffer(x, y2) = b
    Next
    'set the progress bar for each full line
    Call Dogwaffle.Dog_SetProgress(y * (100 / th))
Next
End If
If bmh.biBitcount = 8 Then
'is it an 8 bit image, then use colormap.
Dim Index As Long
For y = 0 To th - 1
x2 = 0
y2 = ((th - 1) - y)
    For x = 0 To tw - 1
    Index = BMPBuffer(x, y)
    c = Colormap(Index)
    'split the long into seperate colors
        b = c And &HFF
        g = (c And &HFF00&) / 256
        r = (c And &HFF0000) / 65536
        MainRBuffer(x, y2) = r
        MainGBuffer(x, y2) = g
        MainBBuffer(x, y2) = b
    Next
    'set the progress bar for each full line
    Call Dogwaffle.Dog_SetProgress(y * (100 / th))
 Next
End If



'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

''we have to set something in the a buffer or we wont see anything
''since bmps don't support alpha, we could create one from the luminance, key to a color, or just set it to all &HFF
''I know, lets ask the user!
'result = Dogwaffle.Dog_QuestionBox("Key to luminance? Cancel for no key.")
''do luminance
'If result = 1 Then
'For y = 0 To th - 1
'For x = 0 To tw - 1
'r = MainRBuffer(x, y)
'g = MainGBuffer(x, y)
'b = MainBBuffer(x, y)
'MainABuffer(x, y) = (r + g + b) / 3
'Next x
'Next y
'Else
''no key
For y = 0 To th - 1
For x = 0 To tw - 1
MainABuffer(x, y) = &HFF
Next x
Next y
'End If

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetBrushRBuffer MainRBuffer()
Dogwaffle.Dog_SetBrushGBuffer MainGBuffer()
Dogwaffle.Dog_SetBrushBBuffer MainBBuffer()
Dogwaffle.Dog_SetBrushABuffer MainABuffer()

'should activate the brush tool.
Dogwaffle.Dog_ActivateCustomBrush
'
'




SkipAll:


End Sub



Public Function ReadBMP(Filename)
Dim MyFilename As String
MyFilename = Filename



Open MyFilename For Binary Access Read As #1
Get #1, , bmfh
'test for a BMP file
If bmfh.bfType1 <> Asc("B") Then ReadBMP = -1: GoTo SkipAll
If bmfh.bftype2 <> Asc("M") Then ReadBMP = -1: GoTo SkipAll
'get the file header
Get #1, , bmh
tw = bmh.biWidth
th = bmh.biHeight
Bitcount = bmh.biBitcount
cmsize = bmh.biClrUsed
If cmsize > 0 Then
ReDim Colormap(cmsize - 1)
'if so, get the colormap
Get #1, , Colormap
End If

'bmps are padded to a 4 byte boundary
Dim pad As Integer
Dim MyWidth As Integer

If (Bitcount < 8) Then ReadBMP = -2: GoTo SkipAll
If (bmh.biCompression <> 0) Then ReadBMP = -3: GoTo SkipAll

'if it's a 24 bit bmp
If (Bitcount = 24) Then
MyWidth = (tw * 3)
dif = MyWidth - (Int(MyWidth / 4) * 4)
If dif = 1 Then MyWidth = MyWidth + 3
If dif = 2 Then MyWidth = MyWidth + 2
If dif = 3 Then MyWidth = MyWidth + 1
ReDim BMPBuffer(MyWidth - 1, th - 1)
End If

'if it's an 8 bit color mapped bmp
If (Bitcount = 8) Then
pad = (tw) - (Int((tw) / 4) * 4)
If pad > 0 Then pad = 4
ReDim BMPBuffer(((Int(tw / 4) * 4) + pad) - 1, th - 1)
End If

'get the bitmap
Get #1, , BMPBuffer

ReadBMP = 0
SkipAll:
Close


End Function




