Attribute VB_Name = "Module1"

Sub Main()
'*** MOSAIC FILTER EXAMPLE ***
'dogwaffle should be running when this code is executed.

Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim alphabits As Byte

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")

'get user input on the size of the mosaic
Dim Blocksize As Integer
Blocksize = Dogwaffle.Dog_ValueBox("Mosaic block size", 2, 16)
If Blocksize = -1 Then Exit Sub


'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
alphabits = Dogwaffle.Dog_GetAlphabits

Dim ystp As Integer

'process the buffers.
'in this case, mosaic.
For y = 0 To th - 1
    For x = 0 To tw - 1
    x2 = Int(x / Blocksize) * Blocksize 'quantise the x and y values
    y2 = Int(y / Blocksize) * Blocksize
        r = MainRBuffer(x2, y2)
        g = MainGBuffer(x2, y2)
        b = MainBBuffer(x2, y2)
        r2 = MainRBuffer(x, y)
        g2 = MainGBuffer(x, y)
        b2 = MainBBuffer(x, y)
        a = MainABuffer(x, y)
        
        'handle alpha channel
        a = a Or alphabits 'if there's an alhpa but it's disabled
        a2 = 255 - a
        r = ((r2 * a2) + (r * a)) / 255
        g = ((g2 * a2) + (g * a)) / 255
        b = ((b2 * a2) + (b * a)) / 255
         
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
        
    Next x
    ystp = ystp + 1
    If ystp >= 10 Then
    ystp = 0
    Call Dogwaffle.Dog_SetProgress((y * (100 / th)))
    End If
Next y

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh

'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

End Sub

