Attribute VB_Name = "Module1"




Sub Main()
'remaps the colors in an image to those of an optimised 256 color palette.
'Although it's really maintained at 24 bits, it could be adapted for saving
'8 bit images.



Dim x As Integer, y As Integer

'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim n As Long, n2 As Long
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")



'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
'Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
'MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
'alphabits = Dogwaffle.Dog_GetAlphabits




'convert to 12 bits simply by dropping the last 3 bits of each color
Dim difr As Integer, difg As Integer, difb As Integer
'setup dither table.  user psudo random for now



Dim d As Byte


'count color usage
Dim P() As Long
Dim p2() As Long
ReDim P(4095)
ReDim p2(4095)
Dim color As Long, color2 As Long


For y = 0 To th
 For x = 0 To tw
 'convert to 12 bit color value
 'this is another one of those times I wish there were shift operations.
 r = MainRBuffer(x, y)
 g = MainGBuffer(x, y)
 b = MainBBuffer(x, y)
 color = (ShiftL(ShiftR(r, 4), 8)) Or (ShiftL(ShiftR(g, 4), 4)) Or (ShiftR(b, 4))
 'add to lookup table
 P(color) = P(color) + 1
 Next
Next


'fill out second array
For n = 0 To 4095
'convert 12 bit style color to 24 bit style
 r = ShiftL((ShiftR(n, 8) And 15), 4)
 g = ShiftL((ShiftR(n, 4) And 15), 4)
 b = ShiftL((n And 15), 4)
 n2 = RGB(r, g, b)
p2(n) = n2
Next


'bubble sort array.  This will be slowish.  A different sorting method
'would probably be better

Dim t As Long, t2 As Long
'
For n2 = 0 To 4095
'
'this was the original internal loop.  It worked fine but was slower.
 For n = 0 To 4094
 'if next is greater than current,
  If P(n + 1) > P(n) Then
  'then swap (first array)
   t = P(n)
   P(n) = P(n + 1)
   P(n + 1) = t
   'second array
   t2 = p2(n)
   p2(n) = p2(n + 1)
   p2(n + 1) = t2
   End If
 Next
'update status bar every 64 times through...
 If (n2 Mod 64) = 0 Then
 Call Dogwaffle.Dog_SetProgress(n2 * (100 / 4095))
 End If
'
Next



'lets get a copy of the top 256 colors
Dim lut() As Long
ReDim lut(255)
For n = 0 To 255
lut(n) = p2(n)
Next


Dim av As Long, av2 As Long
'lets sort it by brightness
'this isn't nescesarry for this plugin, but I'll do it anyway.
For n2 = 0 To 255
 For n = 0 To 254
 color = lut(n)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av = (r + g + b) \ 3
'
 color = lut(n + 1)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av2 = (r + g + b) \ 3
  '
  If av2 > av Then
  'swap
  t = lut(n)
  lut(n) = lut(n + 1)
  lut(n + 1) = t
  End If
 Next
Next


'
'get darkest color in first entry for niceness sake.
'should implement
'
'





'fill a 12 bit color table with the properly remapped values.
'we'll use the first one 'p' since it's not being used anymore.
Dim closest As Long
Dim closestEntry As Long
Dim dif As Long


For n = 0 To 4095
'find the best match for each entry
closest = 255
closestEntry = 0
'n represents on of 4096 different color
'convert n to actual seperate 4 bit colors elements
r = (n And 15)
g = (ShiftR(n, 4) And 15)
b = (ShiftR(n, 8) And 15)
'convert from 12 to 24
r = ShiftL(r, 4)
g = ShiftL(g, 4)
b = ShiftL(b, 4)

For n2 = 0 To 255
'convert lut(n) to rgb colors
 color = lut(n2)
  r2 = (color And &HFF&)
  g2 = (color And &HFF00&) \ 256
  b2 = (color And &HFF0000) \ 65536
  'get difference
  dif = Abs(r - r2) + Abs(g - g2) + Abs(b - b2)
If (dif < closest) Then
closest = dif
closestEntry = n2
P(n) = lut(n2)
End If
Next

Next



'map image through p
For y = 0 To th
 For x = 0 To tw
 r = MainRBuffer(x, y)
 g = MainGBuffer(x, y)
 b = MainBBuffer(x, y)
 'convert to 12 bit address...
 r = ShiftR(r, 4)
 g = ShiftR(g, 4)
 b = ShiftR(b, 4)
 n = (ShiftL(b, 8) Or ShiftL(g, 4) Or r)
 'lookup in table
 color = P(n)
 'convert back to 24 bit color
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  '
  'adjust for lost 15 levels
  r = r * 1.0588
  g = g * 1.0588
  b = b * 1.0588
 '
 'dither
'
'
'

 '
 MainRBuffer(x, y) = r
 MainGBuffer(x, y) = g
 MainBBuffer(x, y) = b
 Next
Next








'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh




'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

'Dogwaffle.dog_SetMousePointer (OldPointer)
'Dogwaffle.Dog_unLock



End Sub





Public Function ShiftR(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftR = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e \ 2
Next

ShiftR = e

End Function

Public Function ShiftL(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftL = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e * 2
Next

ShiftL = e

End Function



