Attribute VB_Name = "Module1"




Sub Main()
'This plugin makes a color well set based on the most prominant colors in the buffer.


'*** Simplistic example of generating a 64 color palette from a 24 bit image ***
'see quantize for the full 256 color version with better comments and everything.




Dim x As Integer, y As Integer

'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim n As Long, n2 As Long
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


dummy = Dogwaffle.Dog_Questionbox("This plugin creates a 64 color palette from the current image and applies it to the color wells.")
If dummy <> 1 Then Exit Sub



'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
'Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
'MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
'alphabits = Dogwaffle.Dog_GetAlphabits



'convert to 12 bits simply by dropping the last 3 bits of each color

For y = 0 To th
 For x = 0 To tw
 MainRBuffer(x, y) = (MainRBuffer(x, y) And 240) 'or &HFF-15
 MainGBuffer(x, y) = (MainGBuffer(x, y) And 240)
 MainBBuffer(x, y) = (MainBBuffer(x, y) And 240)
 Next
Next



'count color usage
Dim P() As Long
Dim p2() As Long
ReDim P(4095)
ReDim p2(4095)
Dim color As Long, color2 As Long


For y = 0 To th
 For x = 0 To tw
 'convert to 16 bit color value
 'this is another one of those times I wish there were shift operations.
 r = MainRBuffer(x, y)
 g = MainGBuffer(x, y)
 b = MainBBuffer(x, y)
 color = (ShiftL(ShiftR(r, 4), 8)) Or (ShiftL(ShiftR(g, 4), 4)) Or (ShiftR(b, 4))
 'add to lookup table
 P(color) = P(color) + 1
 Next
Next


'fill out second array
For n = 0 To 4095
'convert 15 bit style color to 24 bit style
 r = ShiftL((ShiftR(n, 8) And 15), 4)
 g = ShiftL((ShiftR(n, 4) And 15), 4)
 b = ShiftL((n And 15), 4)
 n2 = RGB(r, g, b)
p2(n) = n2
Next


'bubble sort array.  This will be slowish.  A different sorting method
'would probably be better

Dim t As Long, t2 As Long
'
For n2 = 0 To 4095
'
'this was the original internal loop.  It worked fine but was slower.
 For n = 0 To 4094
 'if next is greater than current,
  If P(n + 1) > P(n) Then
  'then swap (first array)
   t = P(n)
   P(n) = P(n + 1)
   P(n + 1) = t
   'second array
   t2 = p2(n)
   p2(n) = p2(n + 1)
   p2(n + 1) = t2
   End If
 Next
'update status bar...
 If (n2 Mod 64) = 0 Then
 Call Dogwaffle.Dog_SetProgress(n2 * (100 / 4095))
 End If
'
Next



'lets get a copy of the top 63 colors
Dim lut() As Long
ReDim lut(63)
For n = 0 To 63
lut(n) = p2(n)
Next


Dim av As Long, av2 As Long
'lets sort it by brightness
For n2 = 0 To 63
 For n = 0 To 62
 color = lut(n)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av = (r * 0.299) + (g * 0.587) + (b * 0.114)
'
 color = lut(n + 1)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av2 = (r * 0.299) + (g * 0.587) + (b * 0.114)
  '
  If av2 > av Then
  'swap
  t = lut(n)
  lut(n) = lut(n + 1)
  lut(n + 1) = t
  End If
 Next
Next



'Put the colors in dogwaffles current gradient.
ReDim MyGradient(63) As Long

For n = 0 To 63
color = lut(n)
 MyGradient(n + 1) = color
Next
MyGradient(0) = lut(63)
'send it to dogwaffle
Dogwaffle.Dog_SetWells MyGradient




'if we wanted to
'send the buffers back to dogwaffle.
'Dogwaffle.Dog_SetRbuffer MainRBuffer()
'Dogwaffle.Dog_SetGbuffer MainGBuffer()
'Dogwaffle.Dog_SetBbuffer MainBBuffer()
'Dogwaffle.Dog_Refresh




'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

'Dogwaffle.dog_SetMousePointer (OldPointer)
'Dogwaffle.Dog_unLock



End Sub





Public Function ShiftR(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftR = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e \ 2
Next

ShiftR = e

End Function

Public Function ShiftL(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftL = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e * 2
Next

ShiftL = e

End Function



