Attribute VB_Name = "Module1"
'
'
'
'this dll routine replace some vb code
'it's slightly faster.  we're talking a few percent.
'if you want to, just use the old vb code
'by removing the comments on the bubble sort's inner loop
'
Declare Sub BubbleInnerds Lib "drFilter" (ByRef b1 As Long, ByRef b2 As Long)
'
'
'
'
'



Sub Main()
'*** Simplistic example of generating a 256 color palette from a 24 bit image ***

'not the worlds fastest or smartest implementation.
'maybe even pretty bad, but it's a starting point.
'meant to be simple...
'the idea is to first conver the image to 15 bit so there's less colors to deal with.  This will help keep processing time down.
'then store the number of times each pixel is used into an array of 32768 elements...
'Another array holds, the original color so it can be retreived after it's sorted.
'then sort the arrays by number of colors and use the first 256 entries of the second array as as the final 256 colors.
'
'if desired, the new 256 color arrays could be sorted again by brightness, but I won't deal with that yet.

'Maby I'll store it in the current dogwaffle gradient

'improvements could include using a different sorting method,
'or discarding colors that are only used a small amount to reduce the number of
'operations in the bubble sort.
'Another option would be to start with a 12 bit palette and that would be pretty fast,
'but thats cutting the quality a bit low.
'coding in C isn't a big improvement.



Dim x As Integer, y As Integer

'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim n As Long, n2 As Long
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


dummy = Dogwaffle.Dog_Questionbox("This plugin creates a 256 color palette from the current image and applies it to the current gradient.  It's not exactly on the fast side.")
If dummy <> 1 Then Exit Sub


'set the mouse pointer
'OldPointer = Dogwaffle.dog_SetMousePointer(11)
'I don't think I'll set the pointer because this can take a long time.


'lock buffer is actually implemented now
'but it must be paired with an unlockbuffer
'so if a routine can possibly fail, don't use it, or make sure the buffer gets unlocked in some fallback code...
'Dogwaffle.Dog_Lock

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
'Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
'MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
'alphabits = Dogwaffle.Dog_GetAlphabits



'convert to 15 bits simply by dropping the last 3 bits of each color

For y = 0 To th
 For x = 0 To tw
 MainRBuffer(x, y) = (MainRBuffer(x, y) And 248) 'or &HFF-7
 MainGBuffer(x, y) = (MainGBuffer(x, y) And 248)
 MainBBuffer(x, y) = (MainBBuffer(x, y) And 248)
 Next
Next



'count color usage
Dim P() As Long
Dim p2() As Long
ReDim P(32768)
ReDim p2(32768)
Dim color As Long, color2 As Long


For y = 0 To th
 For x = 0 To tw
 'convert to 16 bit color value
 'this is another one of those times I wish there were shift operations.
 r = MainRBuffer(x, y)
 g = MainGBuffer(x, y)
 b = MainBBuffer(x, y)
 color = (ShiftL(ShiftR(r, 3), 10)) Or (ShiftL(ShiftR(g, 3), 5)) Or (ShiftR(b, 3))
 'what if would look like in c
 'color  = ((( r ) >> 3) << 10) | ((( g ) >> 2) << 5) | (b >> 3);
 'add to lookup table
 P(color) = P(color) + 1
 Next
Next


'fill out second array
For n = 0 To 32767
'convert 15 bit style color to 24 bit style
 r = ShiftL((ShiftR(n, 10) And 31), 3)
 g = ShiftL((ShiftR(n, 5) And 31), 3)
 b = ShiftL((n And 31), 3)
 n2 = RGB(r, g, b)
p2(n) = n2
Next


'bubble sort array.  This will be slow.  A different sorting method
'would probably be better

Dim t As Long, t2 As Long
'
For n2 = 0 To 32767
'
'this was the original internal loop.  It worked fine but was slower.
' For n = 0 To 32767
' 'if next is greater than current,
'  If P(n + 1) > P(n) Then
'  'then swap (first array)
'   t = P(n)
'   P(n) = P(n + 1)
'   P(n + 1) = t
'   'second array
'   t2 = p2(n)
'   p2(n) = p2(n + 1)
'   p2(n + 1) = t2
'   End If
' Next
'update status bar...

'so here's a new c version.  It's faster, but not much.
BubbleInnerds P(0), p2(0)
'
'

 If (n2 Mod 256) = 0 Then
 Call Dogwaffle.Dog_SetProgress(n2 * (100 / 32767))
 End If
'
Next



'lets get a copy of the top 256 colors
Dim lut() As Long
ReDim lut(255)
For n = 0 To 255
lut(n) = p2(n)
Next


'lets sort it by brightness

Dim av As Long, av2 As Long
For n2 = 0 To 255
 For n = 0 To 254
 color = lut(n)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av = (r * 0.299) + (g * 0.587) + (b * 0.114)
'
 color = lut(n + 1)
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
  av2 = (r * 0.299) + (g * 0.587) + (b * 0.114)
  '
  If av2 > av Then
  'swap
  t = lut(n)
  lut(n) = lut(n + 1)
  lut(n + 1) = t
  End If
 Next
Next



'Put the colors in dogwaffles current gradient.
ReDim MyGradient(255, 2)
Dim MyIndex As Integer
MyIndex = Dogwaffle.Dog_GetGradientIndex()
For n = 0 To 255
color = lut(n)
'put it in the gradient
  r = (color And &HFF&)
  g = (color And &HFF00&) \ 256
  b = (color And &HFF0000) \ 65536
 MyGradient(n, 0) = r
 MyGradient(n, 1) = g
 MyGradient(n, 2) = b
Next
'send it to dogwaffle
Dogwaffle.Dog_SetGradient MyGradient, MyIndex

'if we wanted to
'send the buffers back to dogwaffle.
'Dogwaffle.Dog_SetRbuffer MainRBuffer()
'Dogwaffle.Dog_SetGbuffer MainGBuffer()
'Dogwaffle.Dog_SetBbuffer MainBBuffer()
'Dogwaffle.Dog_Refresh




'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

'Dogwaffle.dog_SetMousePointer (OldPointer)
'Dogwaffle.Dog_unLock


Dogwaffle.dog_Messagebox ("Done")


End Sub





Public Function ShiftR(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftR = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e \ 2
Next

ShiftR = e

End Function

Public Function ShiftL(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftL = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e * 2
Next

ShiftL = e

End Function



