Attribute VB_Name = "Module1"

Sub Main()
'*** Mystic Vision ***
'*** Like the zoom FILTER EXAMPLE ***
'*** but adds on top of the existing image ***
'executable name should end in "_pf.exe" so it gets recognized as a filter plugin
'dogwaffle should be running when this code is executed.

Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim alphabits As Byte
Dim CenterX As Integer, CenterY As Integer
Dim reps As Integer
Dim zscale As Single

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight - 1
tw = Dogwaffle.Dog_BufferWidth - 1

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim MainABuffer() As Byte
'make copies of main buffers to read from
Dim MainRBuffer2() As Byte
Dim MainGBuffer2() As Byte
Dim MainBBuffer2() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
alphabits = Dogwaffle.Dog_GetAlphabits
MainRBuffer2 = MainRBuffer
MainGBuffer2 = MainGBuffer
MainBBuffer2 = MainBBuffer

'Would be extreamly simple to build an interface for this.

'center could be any values really.
CenterX = tw / 2
CenterY = th / 2
reps = 12 'repetitions.
zscale = 0.08


'reset the plugin progress bar
Dogwaffle.Dog_SetProgress 0


'process the buffers.
'in this case, a zooming motion blur effect.
Dim TempScale As Single
For y = 0 To th
    For x = 0 To tw
        r2 = MainRBuffer(x, y)
        g2 = MainGBuffer(x, y)
        b2 = MainBBuffer(x, y)
        r = 0
        g = 0
        b = 0
        TempScale = 1
        For n = 1 To reps
            x2 = ((x - CenterX) * TempScale) + CenterX
            y2 = ((y - CenterY) * TempScale) + CenterY
            If x2 < 0 Then x2 = 0
            If x2 > tw Then x2 = tw
            If y2 < 0 Then y2 = 0
            If y2 > th Then y2 = th
            r = r + MainRBuffer2(x2, y2)
            g = g + MainGBuffer2(x2, y2)
            b = b + MainBBuffer2(x2, y2)
            TempScale = TempScale - (zscale / reps)
        Next
        r = r / reps
        g = g / reps
        b = b / reps
        
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
        
    Next

'set the progress bar for each full line
Call Dogwaffle.Dog_SetProgress(y * (100 / th))
    
Next



'now get the difference from the original image and the zoomed image
'and add it back to the image.
For y = 0 To th
    For x = 0 To tw
        r = MainRBuffer(x, y)
        g = MainGBuffer(x, y)
        b = MainBBuffer(x, y)
        r2 = r - MainRBuffer2(x, y)
        g2 = g - MainGBuffer2(x, y)
        b2 = b - MainBBuffer2(x, y)
        If r2 < 0 Then r2 = 0
        If g2 < 0 Then g2 = 0
        If b2 < 0 Then b2 = 0
        r = MainRBuffer2(x, y) + r2
        g = MainGBuffer2(x, y) + g2
        b = MainBBuffer2(x, y) + b2
        If r > 255 Then r = 255
        If g > 255 Then g = 255
        If b > 255 Then b = 255
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
    Next
Next


'handle the alpha seperately in this case.
If alphabits = 0 Then
For y = 0 To th
    For x = 0 To tw
        r = MainRBuffer(x, y)
        g = MainGBuffer(x, y)
        b = MainBBuffer(x, y)
        r2 = MainRBuffer2(x, y)
        g2 = MainGBuffer2(x, y)
        b2 = MainBBuffer2(x, y)
        a = MainABuffer(x, y)
        a = a Or alphabits 'if there's an alhpa but it's disabled
        a2 = 255 - a
        r = ((r2 * a2) + (r * a)) / 255
        g = ((g2 * a2) + (g * a)) / 255
        b = ((b2 * a2) + (b * a)) / 255
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
    Next
Next
End If


'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh

'allways reset the progress bar if your using it.
Dogwaffle.Dog_SetProgress 0

End Sub

